Index: in/trunk/greenstone3/resources/tomcat/greenstone3.xml.in
===================================================================
--- /main/trunk/greenstone3/resources/tomcat/greenstone3.xml.in	(revision 32312)
+++ 	(revision )
@@ -1,36 +1,0 @@
-<!-- set allowLinking to true if you want to use symlinks to files or directories outside the docBase directory -->
-<!-- set reloadable to false for a production version. if true, automatically reloads the webapp if it detects changes in classes or lib directories -->
-<!-- see http://tomcat.apache.org/tomcat-5.5-doc/config/context.html for more Context attributes -->
-		
-<Context
-	docBase="@gsdl3webwritablehome@" 
-	aliases="/interfaces=@gsdl3webhome@/interfaces,/sites=@gsdl3webhome@/sites"
-	debug="1" reloadable="true" 
-	@privilegedattribute@
-	allowLinking="false"
-	xmlBlockExternal="false">
-
-<!--
-   For embedded derby db:
-   driverName="org.apache.derby.jdbc.EmbeddedDriver"
-   connectionURL="jdbc:derby:@gsdl3webhome@/etc/usersDB"
--->  
-	<Realm className="org.apache.catalina.realm.JDBCRealm" 
-		driverName="org.apache.derby.jdbc.ClientDriver"
-		connectionURL="jdbc:derby://@derbyserver@:@derbyserverport@/@gsdl3webhome@/etc/usersDB"
-		userTable="users" userNameCol="username" userCredCol="password"
-		userRoleTable="roles" roleNameCol="role"
-		/>
-	<!-- Session Manager. Default values are used. See
-	     packages/tomcat/webapps/docs/config/manager.html for more info.
-	     Pathname may be absolute, or relative to greenstone3 context work 
-	     directory: packages/tomcat/work/Catalina/localhost/greenstone3.
-	     Set pathname="" to disable storing session info between restarts. 
-	     To manually clear session info, stop Tomcat and delete the session
-	     file. -->
-	<Manager pathname="SESSIONS.ser" />
-
-	<!-- Allow all machines or just this machine: 127.0.0.1 (IPv4) and 0:0:0:0:0:0:0:1 (IPv6, needed on windows)
-	     https://tomcat.apache.org/tomcat-7.0-doc/config/valve.html -->
-	<Valve className="org.apache.catalina.valves.RemoteAddrValve" allow="@allowedIPs@"/>
-</Context>
Index: /main/trunk/greenstone3/resources/tomcat/greenstone3.xml.svn
===================================================================
--- /main/trunk/greenstone3/resources/tomcat/greenstone3.xml.svn	(revision 32313)
+++ /main/trunk/greenstone3/resources/tomcat/greenstone3.xml.svn	(revision 32313)
@@ -0,0 +1,36 @@
+<!-- set allowLinking to true if you want to use symlinks to files or directories outside the docBase directory -->
+<!-- set reloadable to false for a production version. if true, automatically reloads the webapp if it detects changes in classes or lib directories -->
+<!-- see http://tomcat.apache.org/tomcat-5.5-doc/config/context.html for more Context attributes -->
+		
+<Context
+	docBase="@gsdl3webwritablehome@" 
+	aliases="/interfaces=@gsdl3webhome@/interfaces,/sites=@gsdl3webhome@/sites"
+	debug="1" reloadable="true" 
+	@privilegedattribute@
+	allowLinking="false"
+	xmlBlockExternal="false">
+
+<!--
+   For embedded derby db:
+   driverName="org.apache.derby.jdbc.EmbeddedDriver"
+   connectionURL="jdbc:derby:@gsdl3webhome@/etc/usersDB"
+-->  
+	<Realm className="org.apache.catalina.realm.JDBCRealm" 
+		driverName="org.apache.derby.jdbc.ClientDriver"
+		connectionURL="jdbc:derby://@derbyserver@:@derbyserverport@/@gsdl3webhome@/etc/usersDB"
+		userTable="users" userNameCol="username" userCredCol="password"
+		userRoleTable="roles" roleNameCol="role"
+		/>
+	<!-- Session Manager. Default values are used. See
+	     packages/tomcat/webapps/docs/config/manager.html for more info.
+	     Pathname may be absolute, or relative to greenstone3 context work 
+	     directory: packages/tomcat/work/Catalina/localhost/greenstone3.
+	     Set pathname="" to disable storing session info between restarts. 
+	     To manually clear session info, stop Tomcat and delete the session
+	     file. -->
+	<Manager pathname="SESSIONS.ser" />
+
+	<!-- Allow all machines or just this machine: 127.0.0.1 (IPv4) and 0:0:0:0:0:0:0:1 (IPv6, needed on windows)
+	     https://tomcat.apache.org/tomcat-7.0-doc/config/valve.html -->
+	<Valve className="org.apache.catalina.valves.RemoteAddrValve" allow="@allowedIPs@"/>
+</Context>